/*+-------------------------------------------------------------------------
	ecucurses.h - bypass SCO <curses.h> problems
	wht@n4hgf.atl.ga.us

It is impossible to avoid warnings with various SCO curses installation
options, so we do it here
--------------------------------------------------------------------------*/
/*+:EDITS:*/
/*:11-23-1995-11:20-wht@kepler-source control 3.37 for tsx-11 */
/*:11-14-1995-10:23-wht@kepler-3.37.80-source control point: SOCKETS */
/*:01-12-1995-15:19-wht@n4hgf-apply Andrew Chernov 8-bit clean+FreeBSD patch */
/*:05-04-1994-04:38-wht@n4hgf-ECU release 3.30 */
/*:11-12-1993-11:00-wht@n4hgf-Linux changes by bob@vancouver.zadall.com */
/*:09-10-1992-13:58-wht@n4hgf-ECU release 3.20 */
/*:08-22-1992-15:38-wht@n4hgf-ECU release 3.20 BETA */
/*:03-27-1992-16:21-wht@n4hgf-re-include protection for all .h files */
/*:07-25-1991-12:55-wht@n4hgf-ECU release 3.10 */
/*:05-02-1991-02:35-wht@n4hgf-creation */

#ifndef _ecucurses_h
#define _ecucurses_h

/*
 * remove any pre-conceived notion of TERMINFO vs. TERMCAP curses (SCO)
 */
#if defined(M_TERMINFO)
#undef M_TERMINFO
#endif /* M_TERMINFO */

#if defined(M_TERMCAP)
#undef M_TERMCAP
#endif /* M_TERMCAP */

#if defined(M_SYSV) && !defined(SCO32v5)			 /* any SCO before OS5 */
/*
 * SCO version uses TERMCAP curses at this time
 */
#define M_TERMCAP
#if defined(M_TERMCAP)
#include <tcap.h>
#else /* !M_TERMCAP */
#include <tinfo.h>
#endif /* M_TERMCAP */
#else /* !M_SYSV */

#if defined(sun)			 /* termcap curses for sun and solaris */
#include <curses.h>
#else
/*
 * other uses TERMINFO curses at this time
 */
#define M_TERMINFO			 /* some ecu code requires this despite
							  * non-SCO */
#if defined(LINUX) || defined(__FreeBSD__)
#include <ncurses.h>
#else
#include <curses.h>
#endif /* LINUX */
#endif /* sun */
#endif /* M_SYSV */

#endif /* _ecucurses_h */

/* vi: set tabstop=4 shiftwidth=4: */
/* end of ecucurses.h */
